local LibStub, idTweaks, idTweaksUtils, idTweaksOptions, Option, ToggleOption, split, join, AceConfig, AceConfigDialog, Module
do
  local _obj_0 = _G
  LibStub, idTweaks, idTweaksUtils, idTweaksOptions = _obj_0.LibStub, _obj_0.idTweaks, _obj_0.idTweaksUtils, _obj_0.idTweaksOptions
end
do
  local _obj_0 = idTweaksOptions
  Option, ToggleOption = _obj_0.Option, _obj_0.ToggleOption
end
do
  local _obj_0 = idTweaksUtils.string
  split, join = _obj_0.split, _obj_0.join
end
AceConfig = LibStub("AceConfig-3.0")
AceConfigDialog = LibStub("AceConfigDialog-3.0")
do
  local _class_0
  local _base_0 = {
    set_database = function(self)
      self.addon.db.profile[self.name] = self.addon.db.profile[self.name] or { }
      self.db = self.addon.db.profile[self.name]
    end,
    set_options = function(self)
      self.options = Option(self, self.name, self.name, self.name, { }, {
        enabled = ToggleOption(self, "enabled", "Enabled", "Enables / Disables the Module")
      })
      return self.addon.options:add_option(self.options)
    end,
    initialize = function(self) end,
    check = function(self)
      local enabled_option = self.options:get_option("enabled")
      local is_enabled = enabled_option:get()
      if is_enabled then
        self:enable()
        return self:positioning()
      else
        return self:disable()
      end
    end,
    enable = function(self) end,
    positioning = function(self) end,
    disable = function(self) end
  }
  _base_0.__index = _base_0
  _class_0 = setmetatable({
    __init = function(self, addon, name, ...)
      self.addon = addon
      self.name = name
      self.ace_module = self.addon.ace_addon:NewModule(name, ...)
      self.ace_module.OnInitialize = function()
        self:set_database()
        self:set_options()
        return self:initialize()
      end
      self.ace_module.OnEnable = function()
        return self:check()
      end
      self.ace_module.OnDisable = function()
        return self:disable()
      end
    end,
    __base = _base_0,
    __name = "Module"
  }, {
    __index = _base_0,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  Module = _class_0
end
_G.idTweaksModule = Module
